// FunctionArray.cpp - Demonstrate creating and using an array of function references

#include <iostream>

using namespace std;

// Set up a typedef to create a "FunctionPointer" data type
typedef void(*FunctionPointer)();

// Here are the 7 functions for the days of the week
void Sunday()    { cout << "Sunday"; }
void Monday()    { cout << "Monday"; }
void Tuesday()   { cout << "Tuesday"; }
void Wednesday() { cout << "Wednesday"; }
void Thursday()  { cout << "Thursday"; }
void Friday()    { cout << "Friday"; }
void Saturday()  { cout << "Saturday"; }

int main()
{
	// Create an array of 7 function pointers
	FunctionPointer fp[7] = { Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday };

	cout << "Function Pointer Array\n\n";

	// Call every-other function
	for (int i = 0; i < 7; i += 2)
	{
		cout << i << "  ";
		(fp[i])();
		cout << endl;
	}

	cout << "\nFini\n\n";
	return 0;
}

/* ----- Runtime Output -----

Function Pointer Array

0  Sunday
2  Tuesday
4  Thursday
6  Saturday

Fini

----- End Runtime Output ----- */
